#ifndef PRAGMA_EXEC_H
#define PRAGMA_EXEC_H

/*------ misc --------------------------------------------------------- */
#pragma amicall(SysBase, 0x1E, Supervisor(a5))
/*------ special patchable hooks to internal exec activity ------------ */
/* #pragma amicall(SysBase, 0x24, ExitIntr()) */
/* #pragma amicall(SysBase, 0x2A, Schedule()) */
/* #pragma amicall(SysBase, 0x30, Reschedule()) */
/* #pragma amicall(SysBase, 0x36, Switch()) */
/* #pragma amicall(SysBase, 0x3C, Dispatch()) */
/* #pragma amicall(SysBase, 0x42, Exception()) */
/*------ module creation ---------------------------------------------- */
#pragma amicall(SysBase, 0x48, InitCode(d0,d1))
#pragma amicall(SysBase, 0x4E, InitStruct(a1,a2,d0))
#pragma amicall(SysBase, 0x54, MakeLibrary(a0,a1,a2,d0,d1))
#pragma amicall(SysBase, 0x5A, MakeFunctions(a0,a1,a2))
#pragma amicall(SysBase, 0x60, FindResident(a1))
#pragma amicall(SysBase, 0x66, InitResident(a1,d1))
/*------ diagnostics -------------------------------------------------- */
#pragma amicall(SysBase, 0x6C, Alert(d7))
#pragma amicall(SysBase, 0x72, Debug(d0))
/*------ interrupts --------------------------------------------------- */
#pragma amicall(SysBase, 0x78, Disable())
#pragma amicall(SysBase, 0x7E, Enable())
#pragma amicall(SysBase, 0x84, Forbid())
#pragma amicall(SysBase, 0x8A, Permit())
#pragma amicall(SysBase, 0x90, SetSR(d0,d1))
#pragma amicall(SysBase, 0x96, SuperState())
#pragma amicall(SysBase, 0x9C, UserState(d0))
#pragma amicall(SysBase, 0xA2, SetIntVector(d0,a1))
#pragma amicall(SysBase, 0xA8, AddIntServer(d0,a1))
#pragma amicall(SysBase, 0xAE, RemIntServer(d0,a1))
#pragma amicall(SysBase, 0xB4, Cause(a1))
/*------ memory allocation -------------------------------------------- */
#pragma amicall(SysBase, 0xBA, Allocate(a0,d0))
#pragma amicall(SysBase, 0xC0, Deallocate(a0,a1,d0))
#pragma amicall(SysBase, 0xC6, AllocMem(d0,d1))
#pragma amicall(SysBase, 0xCC, AllocAbs(d0,a1))
#pragma amicall(SysBase, 0xD2, FreeMem(a1,d0))
#pragma amicall(SysBase, 0xD8, AvailMem(d1))
#pragma amicall(SysBase, 0xDE, AllocEntry(a0))
#pragma amicall(SysBase, 0xE4, FreeEntry(a0))
/*------ lists -------------------------------------------------------- */
#pragma amicall(SysBase, 0xEA, Insert(a0,a1,a2))
#pragma amicall(SysBase, 0xF0, AddHead(a0,a1))
#pragma amicall(SysBase, 0xF6, AddTail(a0,a1))
#pragma amicall(SysBase, 0xFC, Remove(a1))
#pragma amicall(SysBase, 0x102, RemHead(a0))
#pragma amicall(SysBase, 0x108, RemTail(a0))
#pragma amicall(SysBase, 0x10E, Enqueue(a0,a1))
#pragma amicall(SysBase, 0x114, FindName(a0,a1))
/*------ tasks -------------------------------------------------------- */
#pragma amicall(SysBase, 0x11A, AddTask(a1,a2,a3))
#pragma amicall(SysBase, 0x120, RemTask(a1))
#pragma amicall(SysBase, 0x126, FindTask(a1))
#pragma amicall(SysBase, 0x12C, SetTaskPri(a1,d0))
#pragma amicall(SysBase, 0x132, SetSignal(d0,d1))
#pragma amicall(SysBase, 0x138, SetExcept(d0,d1))
#pragma amicall(SysBase, 0x13E, Wait(d0))
#pragma amicall(SysBase, 0x144, Signal(a1,d0))
#pragma amicall(SysBase, 0x14A, AllocSignal(d0))
#pragma amicall(SysBase, 0x150, FreeSignal(d0))
#pragma amicall(SysBase, 0x156, AllocTrap(d0))
#pragma amicall(SysBase, 0x15C, FreeTrap(d0))
/*------ messages ----------------------------------------------------- */
#pragma amicall(SysBase, 0x162, AddPort(a1))
#pragma amicall(SysBase, 0x168, RemPort(a1))
#pragma amicall(SysBase, 0x16E, PutMsg(a0,a1))
#pragma amicall(SysBase, 0x174, GetMsg(a0))
#pragma amicall(SysBase, 0x17A, ReplyMsg(a1))
#pragma amicall(SysBase, 0x180, WaitPort(a0))
#pragma amicall(SysBase, 0x186, FindPort(a1))
/*------ libraries ---------------------------------------------------- */
#pragma amicall(SysBase, 0x18C, AddLibrary(a1))
#pragma amicall(SysBase, 0x192, RemLibrary(a1))
#pragma amicall(SysBase, 0x198, OldOpenLibrary(a1))
#pragma amicall(SysBase, 0x19E, CloseLibrary(a1))
#pragma amicall(SysBase, 0x1A4, SetFunction(a1,a0,d0))
#pragma amicall(SysBase, 0x1AA, SumLibrary(a1))
/*------ devices ------------------------------------------------------ */
#pragma amicall(SysBase, 0x1B0, AddDevice(a1))
#pragma amicall(SysBase, 0x1B6, RemDevice(a1))
#pragma amicall(SysBase, 0x1BC, OpenDevice(a0,d0,a1,d1))
#pragma amicall(SysBase, 0x1C2, CloseDevice(a1))
#pragma amicall(SysBase, 0x1C8, DoIO(a1))
#pragma amicall(SysBase, 0x1CE, SendIO(a1))
#pragma amicall(SysBase, 0x1D4, CheckIO(a1))
#pragma amicall(SysBase, 0x1DA, WaitIO(a1))
#pragma amicall(SysBase, 0x1E0, AbortIO(a1))
/*------ resources ---------------------------------------------------- */
#pragma amicall(SysBase, 0x1E6, AddResource(a1))
#pragma amicall(SysBase, 0x1EC, RemResource(a1))
#pragma amicall(SysBase, 0x1F2, OpenResource(a1))
/*------ private diagnostic support ----------------------------------- */
/* #pragma amicall(SysBase, 0x1F8, RawIOInit()) */
/* #pragma amicall(SysBase, 0x1FE, RawMayGetChar()) */
/* #pragma amicall(SysBase, 0x204, RawPutChar()) */
/*------ misc --------------------------------------------------------- */
#pragma amicall(SysBase, 0x20A, RawDoFmt(a0,a1,a2,a3))
#pragma amicall(SysBase, 0x210, GetCC())
#pragma amicall(SysBase, 0x216, TypeOfMem(a1))
#pragma amicall(SysBase, 0x21C, Procure(a0,a1))
#pragma amicall(SysBase, 0x222, Vacate(a0))
#pragma amicall(SysBase, 0x228, OpenLibrary(a1,d0))
/*--- functions in V33 or higher (distributed as Release 1.2) --- */
/*------ signal semaphores (note funny registers)---------------------- */
#pragma amicall(SysBase, 0x22E, InitSemaphore(a0))
#pragma amicall(SysBase, 0x234, ObtainSemaphore(a0))
#pragma amicall(SysBase, 0x23A, ReleaseSemaphore(a0))
#pragma amicall(SysBase, 0x240, AttemptSemaphore(a0))
#pragma amicall(SysBase, 0x246, ObtainSemaphoreList(a0))
#pragma amicall(SysBase, 0x24C, ReleaseSemaphoreList(a0))
#pragma amicall(SysBase, 0x252, FindSemaphore(a1))
#pragma amicall(SysBase, 0x258, AddSemaphore(a1))
#pragma amicall(SysBase, 0x25E, RemSemaphore(a1))
/*------ kickmem support ---------------------------------------------- */
#pragma amicall(SysBase, 0x264, SumKickData())
/*------ more memory support ------------------------------------------ */
#pragma amicall(SysBase, 0x26A, AddMemList(d0,d1,d2,a0,a1))
#pragma amicall(SysBase, 0x270, CopyMem(a0,a1,d0))
#pragma amicall(SysBase, 0x276, CopyMemQuick(a0,a1,d0))
/*------ cache -------------------------------------------------------- */
/*--- functions in V36 or higher (distributed as Preliminary Release 2.0) --- */
#pragma amicall(SysBase, 0x27C, CacheClearU(d0))
#pragma amicall(SysBase, 0x282, CacheClearE(d0))
#pragma amicall(SysBase, 0x288, CacheControl(d0,d1))
/*------ misc --------------------------------------------------------- */
#pragma amicall(SysBase, 0x28E, CreateIORequest(a0,d0))
#pragma amicall(SysBase, 0x294, DeleteIORequest(a0))
#pragma amicall(SysBase, 0x29A, CreateMsgPort())
#pragma amicall(SysBase, 0x2A0, DeleteMsgPort(a0))
#pragma amicall(SysBase, 0x2A6, ObtainSemaphoreShared(a0))
/*------ even more memory support ------------------------------------- */
#pragma amicall(SysBase, 0x2AC, AllocVec(d0,d1))
#pragma amicall(SysBase, 0x2B2, FreeVec(a1))
#pragma amicall(SysBase, 0x2B8, CreatePrivatePool(d0,d1,d2))
#pragma amicall(SysBase, 0x2BE, DeletePrivatePool(a0))
#pragma amicall(SysBase, 0x2C4, AllocPooled(d0,a0))
#pragma amicall(SysBase, 0x2CA, FreePooled(a1,a0))
/*------ misc --------------------------------------------------------- */
#pragma amicall(SysBase, 0x2D0, SetFunction8(d0,d1,a0,a1))
#pragma amicall(SysBase, 0x2D6, ColdReboot())
#pragma amicall(SysBase, 0x2DC, StackSwap(d0,d1,a0))
/*------ task trees --------------------------------------------------- */
#pragma amicall(SysBase, 0x2E2, ChildFree(d0))
#pragma amicall(SysBase, 0x2E8, ChildOrphan(d0))
#pragma amicall(SysBase, 0x2EE, ChildStatus(d0))
#pragma amicall(SysBase, 0x2F4, ChildWait(d0))
/*------ future expansion --------------------------------------------- */
/* #pragma amicall(SysBase, 0x2FA, ExecReserved00(d0)) */
/* #pragma amicall(SysBase, 0x300, ExecReserved01(d0)) */
/* #pragma amicall(SysBase, 0x306, ExecReserved02(d0)) */
/* #pragma amicall(SysBase, 0x30C, ExecReserved03(d0)) */

#endif /* PRAGMA_EXEC_H */
